/*******************************************/
/* Put before the end of the time loop     */
/*******************************************/
// Ver CScreateSensors.H

forAll(probeLocations, pI)
{
    Tsensor[pI]=0.0;
    if ((int)probeCells[pI]>=0) Tsensor[pI] = T[probeCells[pI]];  // measure temperatures
}
reduce( Tsensor, sumOp<List<double> >() ); // communicate temperatures

// Calculate mean temperature
CS_Tmed = 0;
forAll(probeLocations, pI)
{
    CS_Tmed = CS_Tmed + (Tsensor[pI]);
}
if (probeLocations.size()>0) {CS_Tmed = CS_Tmed/probeLocations.size();}

// Control lowerWall temperature
label patchID = mesh.boundaryMesh().findPatchID("lowerWall"); 
fixedValueFvPatchScalarField& WallTemperature = refCast<fixedValueFvPatchScalarField>(T.boundaryField()[patchID]);	
scalarField& TemperatureValue  = WallTemperature;

forAll (TemperatureValue,i) {
    TemperatureValue[i] -= CS_gain.value()*(CS_Tmed-CS_setPoint.value());
}

// Output relevant information (processor 0 only)
if( Pstream::myProcNo() == 0 ) 
{
    Info << endl;
    Info << " *** Control System | mean T: " << CS_Tmed << "oC - ";
    Info << " target T: "   << CS_setPoint.value() << "oC - ";
    Info << " lowerWall T: " << TemperatureValue[0] << "oC - ***" << endl << endl;
}

 
